%define anolis_release 5
Summary: An unwinding library
Name: libunwind
Version: 1.6.2
Release: %{anolis_release}%{?dist}
License: BSD
URL: http://savannah.nongnu.org/projects/libunwind
Source: http://download-mirror.savannah.gnu.org/releases/libunwind/libunwind-%{version}.tar.gz

Patch1: libunwind-skip-no-coredump.patch
Patch2: libunwind-no-dl-iterate-phdr.patch
Patch3: 0001-Add-port-for-Linux-on-LoongArch.patch

ExclusiveArch: aarch64  x86_64 loongarch64 riscv64

BuildRequires: automake libtool autoconf texlive-latex2man
BuildRequires: make
BuildRequires: gcc-c++

# host != target would cause REMOTE_ONLY build even if building i386 on x86_64.
%global _host %{_target_platform}

%description
Libunwind provides a C ABI to determine the call-chain of a program.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary: Development package for libunwind
Requires: libunwind = %{version}-%{release}

%description devel
The libunwind-devel package includes the libraries and header files for
libunwind.

%prep
%autosetup -p1

%build
%global optflags %{optflags} -fcommon
aclocal
libtoolize --force
autoheader
automake --add-missing
autoconf
%configure --enable-static --enable-shared --enable-setjmp=no
make %{?_smp_mflags}

%install
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

# /usr/include/libunwind-ptrace.h
# [...] aren't really part of the libunwind API.  They are implemented in
# a archive library called libunwind-ptrace.a.
mv -f $RPM_BUILD_ROOT%{_libdir}/libunwind-ptrace.a $RPM_BUILD_ROOT%{_libdir}/libunwind-ptrace.a-save
rm -f $RPM_BUILD_ROOT%{_libdir}/libunwind*.a
mv -f $RPM_BUILD_ROOT%{_libdir}/libunwind-ptrace.a-save $RPM_BUILD_ROOT%{_libdir}/libunwind-ptrace.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libunwind-ptrace*.so*

# fix multilib conflicts
touch -r NEWS $RPM_BUILD_ROOT%{_includedir}/libunwind.h

%generate_compatibility_deps

%check
echo ====================TESTING=========================
%ifarch aarch64
echo echo ====================SKIP TEST=====================
%else
  if ! make check ; then
    echo echo ====================FAILED TESTS=====================
    cat tests/test-suite.log || true
  fi
%endif
echo ====================TESTING END=====================

%ldconfig_scriptlets

%files
%license COPYING
%dir %{abidir}
%{_libdir}/libunwind*.so.*
%{abidir}/libunwind*.dump

%files doc
%doc README NEWS

%files devel
%{_libdir}/libunwind*.so
%{_libdir}/libunwind-ptrace.a
%{_libdir}/pkgconfig/libunwind*.pc
%{_mandir}/*/*
# <unwind.h> does not get installed for REMOTE_ONLY targets - check it.
%{_includedir}/unwind.h
%{_includedir}/libunwind*.h

%changelog
* Sun Apr 27 2025 Shangtong Guo <guo.shangtong@zte.com.cn> - 1.6.2-5
- add support for riscv64 build

* Wed Dec 6 2023 Weihao Li <liweihao@loongson.cn> - 1.6.2-4
- Add port for Linux on LoongArch

* Thu Feb 2 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 1.6.2-3
- add abi/api files
- enable self-tests while building. Skip tests for aarch64 since some tests
  may fail

* Thu Sep 29 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.6.2-2
- add doc package

* Thu Apr 07 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.6.2-1
- Init from upstream version 1.6.2

